----
-- upsidedown 17.09.2014

BioGasResiduesTool = {};

function BioGasResiduesTool:prerequisitesPresent(specializations)
    return true;
	--return SpecializationUtil.hasSpecialization(Sprayer, specializations);
end;

function BioGasResiduesTool:load(xmlFile)
	self.hasBiogasResiduesLoaded = false;
	self.BGcounter = 10;
end;

function BioGasResiduesTool:writeStream(streamId, connection)  
	streamWriteBool(streamId, self.hasBiogasResiduesLoaded);
end

function BioGasResiduesTool:readStream(streamId, connection)  
	self.hasBiogasResiduesLoaded = streamReadBool(streamId);
end

function BioGasResiduesTool:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BioGasResiduesTool:keyEvent(unicode, sym, modifier, isDown)
end;

function BioGasResiduesTool:updateTick(dt)		
	if self.currentFillType ~= Fillable.FILLTYPE_LIQUIDMANURE then --e.g. empty, water or simply no lm-vehicle
		self.hasBiogasResiduesLoaded = false;		
	else
		self.BGcounter = self.BGcounter - 1;
		if self.BGcounter < 0 then
			if self.fillLevel >= self.capacity then
				if self.capacity - math.floor(self.capacity) < 0.0001 then
					self.capacity = self.capacity +  0.0001;
				end;
				self.fillLevel = self.capacity - 0.00001;
			end;
			self.BGcounter = 1000; --just check this from time to time to stop filling, but be never so full that residue triggers are not contacted anymore
		end;
	end;
end;

function BioGasResiduesTool:update(dt)
	
end;

function BioGasResiduesTool:draw()
	if self.hasBiogasResiduesLoaded then
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_BioGasResiduesTool") )
	end;
end;

function BioGasResiduesTool:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
  local hasloaded = getXMLBool(xmlFile, key .. "#hasBiogasResiduesLoaded");
  self.hasBiogasResiduesLoaded = Utils.getNoNil(hasloaded,false);

  return BaseMission.VEHICLE_LOAD_OK
end

function BioGasResiduesTool:getSaveAttributesAndNodes(nodeIdent)
 
  local attributes = "hasBiogasResiduesLoaded=\"" .. tostring(self.hasBiogasResiduesLoaded) .. "\""
  return attributes, nil
end


function BioGasResiduesTool:delete()	
end